/*
 * Copyright 2010, 2011 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CARSELECTIONSTATE_H
#define CARSELECTIONSTATE_H

#include "GameState.h"
#include "RenderObject.h"

class CarSelectionState : public GameState
{
public:
	CarSelectionState(int humanPlayers, int computerPlayers, int laps, int tracks, bool tournament, bool carCollisions, int difficulty);
	virtual void onKeyDown(SDLKey key);
	virtual void update();
private:
	struct Car
	{
		bool taken;
		int id;
		RenderObject renderObject;
	};

	void nextCar();
	void prevCar();
	void selectCar();
	void enterNextState();
	
	int humanPlayers;
	int computerPlayers;
	int laps;
	int tracks;
	bool tournament;
	bool carCollisions;
	int difficulty;
	
	RenderObject titleRO;
	Car cars[8];
	
	int selectedCar;
	std::vector<int> playerCars;
};


#endif
