/*
 * Copyright 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONTROLLERSETTINGS_H
#define CONTROLLERSETTINGS_H

#include "GameState.h"
#include "Menu.h"

class Driver;

class ControllerSettings : public GameState
{
public:
	ControllerSettings();
	~ControllerSettings();
	virtual void update();
	virtual void onKeyDown(SDLKey key);
	virtual bool onEvent(const SDL_Event& event);
	void updatePlayer();
	void updateDevice();
	void updateControl(int i);
private:
	Menu menu;
	int player;
	int device;
	bool returnToMainMenu;
	int mode;
	bool enterControlMode[4];
	std::vector<Driver*> drivers[8];
	int deviceIndices[8];
};

#endif
