/*
 * Copyright 2010, 2011, 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "GameState.h"
#include "StateManager.h"
#include <cassert>
#include <algorithm>

Surface GameState::background;

GameState::GameState()
{
}

GameState::~GameState()
{
}

void GameState::update()
{
}

int GameState::sleepTime()
{
	return 20;
}

void GameState::onKeyDown(SDLKey)
{
}

void GameState::onKeyUp(SDLKey)
{
}

void GameState::onUnicode(Uint16)
{
}

bool GameState::onEvent(const SDL_Event& event)
{
	return false;
}

void GameState::addRenderObject(RenderObject& ro, int z)
{
	assert(std::find(renderObjects.begin(), renderObjects.end(), &ro) == renderObjects.end());
	
	ro.flagUpdated();
	
	for (std::size_t i = 0; i < renderObjects.size(); i++)
	{
		if (renderObjectsZ[i] > z)
		{
			renderObjects.insert(renderObjects.begin() + i, &ro);
			renderObjectsZ.insert(renderObjectsZ.begin() + i, z);
			return;
		}
	}
	// if we know the object should be added to the end. 
	renderObjects.push_back(&ro);
	renderObjectsZ.push_back(z);
}

void GameState::removeRenderObject(RenderObject& ro)
{
	for (std::size_t i = 0; i < renderObjects.size(); i++)
	{
		if (renderObjects[i] == &ro)
		{
			renderObjects.erase(renderObjects.begin() + i);
			renderObjectsZ.erase(renderObjectsZ.begin() + i);
			Rect rect;
			ro.getOldRect(rect);
			StateManager::getInstance().addUpdateRect(rect);
		}
	}
}
