/*
 * Copyright 2010, 2011, 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GAMESTATE_H
#define GAMESTATE_H

#include "Surface.h"
#include "Menu.h"
#include <vector>


class RenderObject;


class GameState
{
public:
	GameState();
	virtual ~GameState();
public:
	virtual void update();
	virtual int sleepTime();
	virtual void onKeyDown(SDLKey key);
	virtual void onKeyUp(SDLKey key);
	virtual void onUnicode(Uint16 unicode);
	virtual bool onEvent(const SDL_Event& event);

protected:
	void addRenderObject(RenderObject& ro, int z = 0);
	void removeRenderObject(RenderObject& ro);
	static Surface background;
private:
	std::vector<RenderObject*> renderObjects;
	std::vector<int> renderObjectsZ;
	
	friend class StateManager;
	friend void Menu::addRenderObjects(GameState*, int, int, int, int);
	friend void Menu::reset(GameState*);
};

#endif



