/*
 * Copyright 2011, 2012 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "InRaceMenu.h"
#include "StateManager.h"

InRaceMenu::InRaceMenu(bool& endRace)
:	endRaceAction(endRace),
	continueAction(false),
	quitAction(false)
{
	SDL_Rect rect = {111, 91, 108, 41};
	background.fill(235, 235, 235, &rect);
	
	menu.addItem("Continue race", &continueAction);
	menu.addItem("End race", &endRaceAction);
	menu.addItem("Quit to main menu", &quitAction);
	menu.addRenderObjects(this, 116, 96, 0, 12);
}

void InRaceMenu::update()
{
}

void InRaceMenu::onKeyDown(SDLKey key)
{
	menu.onKeyDown(key);
	
	if (continueAction || endRaceAction || key == SDLK_ESCAPE)
	{
		StateManager::getInstance().enterPrevState();
	}
	else if (quitAction)
	{
		StateManager::getInstance().enterMainMenuState();
	}
}
