/*
 * Copyright 2010, 2011, 2012, 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MainMenu.h"
#include "StateManager.h"

const Color TITLE_COLOR = {0xFF, 0xDD, 0x10};

MainMenu::MainMenu()
:	singleRaceAction(false),
	tournamentAction(false),
	controllerSettingsAction(false),
	quitAction(false)
{
	background.fill(120, 124, 224);
	Surface title("Brum brum rally", BIG_FONT, TITLE_COLOR);
	title.draw(background, 115, 30);
	
	menu.addItem("Single race", &singleRaceAction);
	menu.addItem("Tournament", &tournamentAction);
	menu.addItem("Controller settings", &controllerSettingsAction);
	menu.addItem("Quit game", &quitAction);
	menu.addRenderObjects(this, 120, 100, 10, 10);
}

void MainMenu::update()
{
	if (singleRaceAction)
	{
		StateManager::getInstance().enterRacePreparationMenuState(false);
	}
	else if (tournamentAction)
	{
		StateManager::getInstance().enterRacePreparationMenuState(true);
	}
	else if (controllerSettingsAction)
	{
		StateManager::getInstance().enterControllerSettings();
	}
	else if (quitAction)
	{
		StateManager::getInstance().enterQuitState();
	}
}

void MainMenu::onKeyDown(SDLKey key)
{
	menu.onKeyDown(key);
}
