/*
 * Copyright 2012 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PATH_H
#define PATH_H

#include <string>
#include <vector>

class Path
{
public:
	Path();
	Path(const std::string& p);
	Path parent() const;
	Path operator+(const std::string& filename) const;
	Path& operator+=(const std::string& filename);
	operator const std::string&() const;
	const char* c_str() const;
	
	bool isDir() const;
	bool isFile() const;
	bool exist();
	bool mkdir();
	
	
	std::vector<std::string> files() const;
	
private:
	void format();

	std::string path;
};
std::ostream& operator<<(std::ostream& s, const Path& p);

const Path& dataPath();
const Path& configPath();

#endif
