/*
 * Copyright 2010, 2011, 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef RACEPREPARATIONMENU_H
#define RACEPREPARATIONMENU_H

#include "GameState.h"
#include "Menu.h"
#include "Path.h"

class RacePreparationMenu : public GameState
{
public:
	RacePreparationMenu(bool tournament);
	~RacePreparationMenu();
	virtual void onKeyDown(SDLKey key);
private:
	void save() const;
	void load();

	int humanPlayers;
	int computerPlayers;
	int laps;
	int tracks;
	int tournament;
	int collisions;
	int difficulty;
	
	bool moveToNext;
	bool actionNext;
	
	Menu menu;
	Path path;
};

#endif
