/*
 * Copyright 2010, 2011 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef RENDEROBJECT_H
#define RENDEROBJECT_H

#include "Surface.h"
#include "Rect.h"

class Surface;

class RenderObject
{
public:
	RenderObject();
	RenderObject(const Surface& surface, int x, int y, double rotate = 0.0f);
	void update(int x, int y, double rotate);
	void moveTo(int x, int y);
	void setRotation(double rotate);
	void updateRects(Rect& newRect, Rect& oldRect);
	void getOldRect(Rect& rect);
	bool isUpdated() const;
	void flagUpdated();
	void draw(Surface& dst);
	void setSurface(const Surface& surf);
private:
	bool updated;
	int x;
	int y;
	double rotationAngle;
	Surface surface;
	Rect prevRect;
};

#endif
