/*
 * Copyright 2011, 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef RESULTSTATE_H
#define RESULTSTATE_H

#include "GameState.h"
#include "RaceSetup.h"

class ResultState : public GameState
{
public:
	ResultState(const RaceSetup& raceSetup);
	virtual void update();
	virtual void onKeyDown(SDLKey key);
private:
	RaceSetup raceSetup;
	Menu menu;
	bool nextAction;
	bool quitAction;
	bool pointsAction;
	
	bool haveWinner;
	RenderObject leftWinnerTextRO;
	RenderObject rightWinnerTextRO;
	RenderObject winningCarRO;
	double winningCarRotation;
	int winnerTextTimer;
	std::string extraTitle;
};

#endif
