/*
 * Copyright 2012 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TILESET_H
#define TILESET_H

#include "Surface.h"
#include <vector>

class Map;

class TileSet
{
public:
	
	TileSet(const Surface& surface);
	void decorate(const Map& map, int finishX, int finishY, Surface& background) const;
	static const TileSet& getRandomTileSet();
private:
	const Surface& pickTile(const Map& map, int x, int y, int finishX, int finishY) const;
	TileSet(){}
	
	std::vector<Surface> tiles;
	Uint32 wallColor;
};

#endif
