/*
 * Copyright 2010, 2011, 2012, 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "StateManager.h"
#include "RaceState.h"
#include "Path.h"
#include "SDL_image.h"
#include <cstdlib>
#include <ctime>
#include <cstring>

// IMG_Init/IMG_Quit was introduced in SDL_image 1.2.8
#if SDL_IMAGE_MAJOR_VERSION < 1 || (SDL_IMAGE_MAJOR_VERSION == 1 && (SDL_IMAGE_MINOR_VERSION < 2 || (SDL_IMAGE_MINOR_VERSION == 2 && SDL_IMAGE_PATCHLEVEL < 8)))
#define IMG_Init(x)
#define IMG_Quit()
#endif

int main(int argc, char *argv[])
{
	// seed the random number
	std::srand(std::time(0));

	// Initialize SDL
	SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO|SDL_INIT_JOYSTICK);// SDL_INIT_AUDIO 
	IMG_Init(IMG_INIT_PNG);
	SDL_WM_SetCaption("Brum Brum Rally", 0);
	if (SDL_Surface* icon = IMG_Load((dataPath() + "/images/icon.png").c_str()))
	{
		SDL_WM_SetIcon(icon, 0);
		SDL_FreeSurface(icon);
	}

	// run the state manager
	StateManager& stateManager = StateManager::getInstance();
	stateManager.enterMainMenuState();
	stateManager.run();
	
	// cleans up SDL
	stateManager.cleanUp();
	IMG_Quit();
	SDL_Quit();
	return 0; 
}
